package com.ruoyi.busi.controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.base.service.IBasePicsService;
import com.ruoyi.busi.vo.ProdNewVO;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.busi.domain.BusiProdNew;
import com.ruoyi.busi.service.IBusiProdNewService;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

import static com.ruoyi.constant.DictConstants.FILE_TYPE_PRODUCT;

/**
 * 产品Controller
 * 
 * @author vinjor-m
 * @date 2025-06-25
 */
@RestController
@RequestMapping("/busi/prod")
public class BusiProdController extends BaseController
{
    @Autowired
    private IBusiProdNewService busiProdNewService;
    @Autowired
    private IBasePicsService basePicsService;

    /**
     * 查询产品列表
     */
    @PreAuthorize("@ss.hasPermi('busi:prod:list')")
    @GetMapping("/list")
    public AjaxResult list(BusiProdNew busiProdNew,
                                @RequestParam(name = "pageNum", defaultValue = "1") Integer pageNum,
                                @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize)
    {
        Page<BusiProdNew> page = new Page<>(pageNum, pageSize);
        IPage<ProdNewVO> list = busiProdNewService.queryListPage(busiProdNew,page);
        return success(list);
    }

    /**
     * 导出产品列表
     */
    @PreAuthorize("@ss.hasPermi('busi:prod:export')")
    @Log(title = "产品", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BusiProdNew busiProdNew)
    {
        List<BusiProdNew> list = busiProdNewService.list();
        ExcelUtil<BusiProdNew> util = new ExcelUtil<BusiProdNew>(BusiProdNew.class);
        util.exportExcel(response, list, "产品、文章数据");
    }

    /**
     * 获取产品详细信息
     */
    @PreAuthorize("@ss.hasPermi('busi:prod:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") String id)
    {
        return success(busiProdNewService.getById(id));
    }

    /**
     * 获取产品表当前最大排序
     */
    @GetMapping(value = "/getMaxSort")
    public AjaxResult getMaxSort(String tenantId)
    {
        return success(busiProdNewService.getMaxSort(tenantId));
    }

    /**
     * 新增产品
     */
    @PreAuthorize("@ss.hasPermi('busi:prod:add')")
    @Log(title = "产品", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody ProdNewVO prodNewVO){
        busiProdNewService.save(prodNewVO);
        if(null!=prodNewVO.getFileList() && !prodNewVO.getFileList().isEmpty()){
            prodNewVO.getFileList().forEach(item->{
                item.setTenantId(prodNewVO.getTenantId());
                item.setFileType(FILE_TYPE_PRODUCT);
            });
        }
        return success();
    }

    /**
     * 修改产品
     */
    @PreAuthorize("@ss.hasPermi('busi:prod:edit')")
    @Log(title = "产品", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody ProdNewVO prodNewVO){
        busiProdNewService.updateById(prodNewVO);
        if(null!=prodNewVO.getFileList() && !prodNewVO.getFileList().isEmpty()){
            prodNewVO.getFileList().forEach(item->{
                item.setTenantId(prodNewVO.getTenantId());
                item.setFileType(FILE_TYPE_PRODUCT);
            });
        }
        return success();
    }

    /**
     * 删除产品
     */
    @PreAuthorize("@ss.hasPermi('busi:prod:remove')")
    @Log(title = "产品", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable String[] ids){
        List<String> list = new ArrayList<>(Arrays.asList(ids));
        return toAjax(busiProdNewService.removeByIds(list));
    }
}
